<?
// PHP Script to take the contents of a posted form and email it to a recipient named in an XML config file
// The email addresses will be linked using an 'id', unique to each email address.  Multiple recipients should use a list
//
// Written by Richard Webber 20/07/2005


$configfile = "sendform_mailconf.xml";
$exclude_fields_from_email = array('next_url' => null,'email_id' => null,'submit' => null,'subject' => null);


$required_fields = array('next_url');
function js_alert($msg) {
  echo (
    "\n<SCRIPT LANGUAGE='JavaScript'>\n" .
    "  <!-- \n" .
    "  alert (\"$msg\");\n" .
    "  history.back();\n" .
    "  // --> \n" .
    "</SCRIPT>"
  );
  exit;
}


function findEmailAddress($email_id) {

	global $tag, $email_id, $email_address, $default_email_address, $configfile;

	$insideitem = false;
	$tag = "";
	$email_id = "";
	$email_address = "";
	
	$xml_parser = xml_parser_create();
	xml_set_element_handler($xml_parser, "startElement", "endElement");
	xml_set_character_data_handler($xml_parser, "characterData");
	$fp = fopen($configfile,"r") or die("Error reading XML data.");
	while ($data = fread($fp, 4096))
	xml_parse($xml_parser, $data, feof($fp)) or die(sprintf("XML error: %s at line %d", 
	xml_error_string(xml_get_error_code($xml_parser)), 
	xml_get_current_line_number($xml_parser)));
	fclose($fp);
	xml_parser_free($xml_parser);
	
	$email_address = stripslashes(htmlspecialchars(trim($email_address)));
	//js_alert($email_address);
	return $email_address;

}


function startElement($parser, $name, $attrs) {
	global $tag, $email_id, $email_address;
	$name = stripslashes($name);
	$tag = $name;
}

function endElement($parser, $name) {
	global $tag, $email_id, $email_address;
	if ($name == "ADDRESS") {
		//print "End of elelment email id is ".htmlspecialchars(trim($email_id))." ";
		//print "End of element address is ".htmlspecialchars(trim($email_address))."<br>";
		$email_id = "";
		//$email_address = "";
	}
}

function characterData($parser, $data) {

	global  $tag, $email_id, $email_address;

		switch ($tag) {
		case "DEFAULT":
			if (strlen($_POST['email_id']) < 1) {
				$email_address .= $data;
			}
			break;
		case "ID":
		$email_id .= trim($data);
		break;
		case "RECIPIENT":
			//print "Currently examining ".$email_id." with ".$_POST['email_id']."<br>";
			$form_email_id = trim($_POST['email_id']);
			if ($email_id == $form_email_id) {
				//print "INSIDE IF, email address is $data<br>";
				$email_address .= $data;
			}
	
	}
}

// Start Main program

// Check that form was submitted from a *.soton.ac.uk server

$from_serv = $_SERVER['HTTP_REFERER'];
$check_serv = "f";

if (preg_match ("/.*\.soton\.ac\.uk.*/i", $from_serv)) {
	$check_serv = "t";
}

if (preg_match ("/.*\.southampton\.ac\.uk.*/i", $from_serv)) {
	$check_serv = "t";
}

if ($check_serv == "f") {
	echo "<p>Error, form not submitted from a University of Southampton server</p>";
	exit;
}

// Check for required fields

foreach ($required_fields as $field) {
		if (!array_key_exists($field, $_POST)) {
				echo "Missing field $field<br>";
		        exit;
		}
}

// Check for comment spam 

foreach ($_POST as $fieldname => $value) {

	$value = trim($value);

	if (preg_match("/\[URL ?= ?\"?https?:\/\//im", $value)) {
		echo "We do not accept comment spam. ;-)";
		exit;
	}

}

// Find email address associated with email_id

$email_address = findEmailAddress($POST['email_id']);

//print "Email address is $email_address<br>";

// Read contents from form and construct email to recipient

$email_text = "A form on your website has been submitted.  Below are the contents of that submitted form\n\n\n";

/* foreach ($_POST as $fieldname => $value) {

   $value = htmlspecialchars(trim($value));

   if (!array_key_exists($fieldname, $exclude_fields_from_email)) {
	   $email_text .= $fieldname." : ".$value."\n";
   }
}
*/
foreach ($_POST as $fieldname => $value) {

 if(is_array($value)) {
	foreach($value as $v2) {
		$v2 = htmlspecialchars(trim($v2));
   	    if (!array_key_exists($fieldname, $exclude_fields_from_email)) {
			$email_text .= $fieldname." : ".$v2."\n";

		}
	}
  } else {
	$value = htmlspecialchars(trim($value),ENT_NOQUOTES);
	$value = stripslashes($value);
	if (!array_key_exists($fieldname, $exclude_fields_from_email)) {
		$email_text .= $fieldname." : ".$value."\n";
	   }
   }
}


$email_text .= "\n";
$email_text .= "======================================================\n";
$email_text .= "NOTE:  This message was sent through the WWW mail form\n";
$email_text .= "    Please contact webmaster@soton.ac.uk if this email\n";
$email_text .= "    should not have come to you \n";
$email_text .= "======================================================\n";
$email_text .= "HOST: ".$_SERVER['REMOTE_HOST']." ".$_SERVER['REMOTE_ADDR']."\n";
$email_text .= "FORM: ".$_SERVER['HTTP_REFERER']."\n";
$email_text .= "======================================================\n";
$email_text .="\n";



// Send the email

// In case any of our lines are larger than 70 characters, we should use wordwrap()
$email_text = wordwrap($email_text, 70);

if (array_key_exists('subject',$_POST)) {
	$subject = $_POST['subject'];
} else {
	$subject = 'Web Form Submitted';
}

$headers = 'From: DoNotReply@soton.ac.uk' . "\r\n" .
   'Reply-To: DoNotReply@soton.ac.uk' . "\r\n" .
   'X-Mailer: PHP/' . phpversion();

mail($email_address, $subject, $email_text, $headers);

// Send the browser to the next_url page

header("Location: $next_url");

 
?>
